Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_message.cpp	(revision 1520)
@@ -18,86 +18,184 @@
 namespace ep_lib
 {
-
+  int Request_Check()
+  {
+    if(EP_PendingRequests == 0 ) EP_PendingRequests = new std::list< MPI_Request* >;
+    
+    if(EP_PendingRequests->size() == 0) return 0;
+    
+    MPI_Status status;
+    MPI_Message *message;
+    int probed = false;
+    int recv_count = 0;
+    std::list<MPI_Request* >::iterator it;
+    
+    
+    for(it = EP_PendingRequests->begin(); it!=EP_PendingRequests->end(); it++)
+    { 
+      Message_Check(((*(*it))->comm));
+    }
+
+
+    for(it = EP_PendingRequests->begin(); it!=EP_PendingRequests->end(); )
+    {
+      if((*(*it))->state == 0)
+      {
+        #pragma omp critical (_query0)
+        {
+          MPI_Iprobe((*(*it))->ep_src, (*(*it))->ep_tag, ((*(*it))->comm), &probed, &status);
+          if(probed)
+          {
+            message = new MPI_Message;
+            *message = new ep_message;
+        
+            memcheck("new "<< message <<" : in ep_lib::Request_Check, message = new MPI_Message");
+            memcheck("new "<< *message <<" : in ep_lib::Request_Check, *message = new ep_message");
+          
+          
+            MPI_Improbe((*(*it))->ep_src, (*(*it))->ep_tag, (*(*it))->comm, &probed, message, &status);
+        
+          }
+        }
+      
+        
+        if(probed)
+        {
+          MPI_Get_count(&status, (*(*it))->ep_datatype, &recv_count);
+          
+          MPI_Imrecv((*(*it))->buf, recv_count, (*(*it))->ep_datatype, message, *it);
+          (*(*it))->type = 3;
+          (*(*it))->state = 1;
+
+          memcheck("delete "<< status.mpi_status <<" : in ep_lib::Request_Check, delete status.mpi_status");
+          delete status.mpi_status;          
+
+          memcheck("delete "<< *message <<" : in ep_lib::Request_Check, delete *message");
+          memcheck("delete "<< message <<" : in ep_lib::Request_Check, delete message");
+
+          delete *message;
+          delete message;
+        
+          it++;
+          continue;      
+        }              
+      }
+      
+      if((*(*it))->state == 2)
+      {
+        int ep_rank = ((*(*it))->comm)->ep_comm_ptr->size_rank_info[0].first;
+        memcheck("delete "<< (*(*it)) <<" : in ep_lib::Request_Check, delete (*(*it))");
+        
+        
+        int world_rank;
+        MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
+        if(world_rank==2) 
+        {
+          printf("ep %d erased one pending request %p\n", world_rank,*(*it));
+        }
+        
+        EP_PendingRequests->erase(it);
+        
+        memcheck("EP_PendingRequests["<<ep_rank<<"]->size() = " << EP_PendingRequests->size());
+        it = EP_PendingRequests->begin();
+        continue;
+      }
+      else it++;
+    }
+  }
+  
+  
+  
   int Message_Check(MPI_Comm comm)
   {
-    if(!comm.is_ep) return 0;
-
-    if(comm.is_intercomm)
-    {
-      return  Message_Check_intercomm(comm);
-    }
+    if(!comm->is_ep) return MPI_SUCCESS;
+
+    if(comm->is_intercomm)
+    {
+      Message_Check_intercomm(comm);
+    }
+    
+    return Message_Check_intracomm(comm);
+
+  }
+  
+  
+  int Message_Check_intracomm(MPI_Comm comm)
+  {
+    
+    int flag = true;
+    ::MPI_Status status;
+    ::MPI_Message message;
+
+    while(flag) // loop until the end of global queue
+    {
+      Debug("Message probing for intracomm\n");
+     
+      #pragma omp critical (_mpi_call)
+      {
+        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm->mpi_comm), &flag, &status);
+        if(flag)
+        {
+          Debug("find message in mpi comm \n");
+          ::MPI_Mprobe(status.MPI_SOURCE, status.MPI_TAG, to_mpi_comm(comm->mpi_comm), &message, &status);
+        }
+      }
+
+      
+      if(flag)
+      {
+        MPI_Message msg = new ep_message; 
+        msg->mpi_message = new ::MPI_Message(message);
+
+        memcheck("new "<< msg <<" : in ep_lib::Message_Check, msg = new ep_message");
+        memcheck("new "<< msg->mpi_message <<" : in ep_lib::Message_Check, msg->mpi_message = new ::MPI_Message");
+              
+
+        msg->ep_tag  = bitset<15>(status.MPI_TAG >> 16).to_ulong(); 
+        int src_loc  = bitset<8> (status.MPI_TAG >> 8) .to_ulong(); 
+        int dest_loc = bitset<8> (status.MPI_TAG)	    .to_ulong();
+        int src_mpi  = status.MPI_SOURCE;
+             
+        msg->ep_src  = get_ep_rank(comm, src_loc,  src_mpi);  
+
+#ifdef _showinfo
+        printf("status.MPI_TAG = %d, src_loc = %d, dest_loc = %d, ep_tag = %d\n", status.MPI_TAG, src_loc, dest_loc, msg->ep_tag);
+#endif
+
+        msg->mpi_status = new ::MPI_Status(status);  
+        memcheck("new "<< msg->mpi_status <<" : in ep_lib::Message_Check, msg->mpi_status = new ::MPI_Status");
+
+        #pragma omp critical (_query)
+        {
+          #pragma omp flush
+          comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->push_back(msg);  
+          int dest_mpi = comm->ep_comm_ptr->size_rank_info[2].first;
+          memcheck("message_queue["<<dest_mpi<<","<<dest_loc<<"]->size = "<<comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->size());
+          #pragma omp flush
+        }
+      }
+    }
+
+    return MPI_SUCCESS;
+  }
+
+
+  
+  
+  
+
+
+  int Message_Check_intercomm(MPI_Comm comm)
+  {
+    if(!comm->ep_comm_ptr->intercomm->mpi_inter_comm) return 0;
+
+    Debug("Message probing for intercomm\n");
 
     int flag = true;
     ::MPI_Message message;
     ::MPI_Status status;
-    int mpi_source;
-
-    while(flag) // loop until the end of global queue
-    {
-      Debug("Message probing for intracomm\n");
-      
-      #pragma omp critical (_mpi_call)
-      {
-        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm.mpi_comm), &flag, &status);
-        if(flag)
-        {
-          Debug("find message in mpi comm \n");
-          mpi_source = status.MPI_SOURCE;
-          int tag = status.MPI_TAG;
-          ::MPI_Mprobe(mpi_source, tag, to_mpi_comm(comm.mpi_comm), &message, &status);
-
-        }
-      }
-
-      
-      if(flag)
-      {
-
-        MPI_Message *msg_block = new MPI_Message; 
-        msg_block->mpi_message = new ::MPI_Message;
-        *(static_cast< ::MPI_Message*>(msg_block->mpi_message)) = message;  
-        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong(); 
-        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong(); 
-        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();
-        int src_mpi       = status.MPI_SOURCE;
-             
-        msg_block->ep_src  = get_ep_rank(comm, src_loc,  src_mpi);       
-        msg_block->mpi_status = new ::MPI_Status(status);
-
-        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
-        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
-
-
-        #pragma omp critical (_query)
-        {
-          #pragma omp flush
-          comm.ep_comm_ptr->comm_list[dest_loc].ep_comm_ptr->message_queue->push_back(*msg_block);      
-          #pragma omp flush
-        }
-        
-        delete msg_block;
-      }
-
-    }
-
-    return MPI_SUCCESS;
-  }
-
-
-
-  int Message_Check_intercomm(MPI_Comm comm)
-  {
-    if(!comm.ep_comm_ptr->intercomm->mpi_inter_comm) return 0;
-
-    Debug("Message probing for intercomm\n");
-
-    int flag = true;
-    ::MPI_Message message;
-    ::MPI_Status status;
-    int mpi_source;
     int current_ep_rank;
     MPI_Comm_rank(comm, &current_ep_rank);
 
-    while(flag) // loop until the end of global queue "comm.ep_comm_ptr->intercomm->mpi_inter_comm"
+    while(flag) // loop until the end of global queue "comm->ep_comm_ptr->intercomm->mpi_inter_comm"
     {
       Debug("Message probing for intracomm\n");
@@ -105,12 +203,9 @@
       #pragma omp critical (_mpi_call)
       {
-        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &flag, &status);
+        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), &flag, &status);
         if(flag)
         {
           Debug("find message in mpi comm \n");
-          mpi_source = status.MPI_SOURCE;
-          int tag = status.MPI_TAG;
-          ::MPI_Mprobe(mpi_source, tag, to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &message, &status);
-
+          ::MPI_Mprobe(status.MPI_SOURCE, status.MPI_TAG, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), &message, &status);
         }
       }
@@ -120,117 +215,40 @@
       {
 
-        MPI_Message *msg_block = new MPI_Message;
-        msg_block->mpi_message = new ::MPI_Message;
-        *(static_cast< ::MPI_Message*>(msg_block->mpi_message)) = message;
-        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong();
-        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong();
-        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();
-        int src_mpi       = status.MPI_SOURCE;
-        int current_inter = comm.ep_comm_ptr->intercomm->local_rank_map->at(current_ep_rank).first;
+        MPI_Message msg = new ep_message; 
+        msg->mpi_message = new ::MPI_Message(message);
+
+        memcheck("new "<< msg <<" : in ep_lib::Message_Check, msg = new ep_message");
+        memcheck("new "<< msg->mpi_message <<" : in ep_lib::Message_Check, msg->mpi_message = new ::MPI_Message");
+              
+
+        msg->ep_tag  = bitset<15>(status.MPI_TAG >> 16).to_ulong(); 
+        int src_loc  = bitset<8> (status.MPI_TAG >> 8) .to_ulong(); 
+        int dest_loc = bitset<8> (status.MPI_TAG)	    .to_ulong();
+        int src_mpi  = status.MPI_SOURCE;
              
-        msg_block->ep_src  = get_ep_rank_intercomm(comm, src_loc,  src_mpi);
-        msg_block->mpi_status = new ::MPI_Status(status);
-
-
-        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
-        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
-
+        msg->ep_src  = get_ep_rank(comm, src_loc,  src_mpi);   
+#ifdef _showinfo
+        printf("status.MPI_TAG = %d, src_loc = %d, dest_loc = %d, ep_tag = %d\n", status.MPI_TAG, src_loc, dest_loc, msg->ep_tag);
+#endif
+
+        msg->mpi_status = new ::MPI_Status(status); 
+        memcheck("new "<< msg->mpi_status <<" : in ep_lib::Message_Check, msg->mpi_status = new ::MPI_Status");
 
         #pragma omp critical (_query)
         {
           #pragma omp flush
-          comm.ep_comm_ptr->comm_list[dest_loc].ep_comm_ptr->message_queue->push_back(*msg_block);
-          #pragma omp flush
-        }
-        
-        delete msg_block;
-        
-      }
-
-    }
-
-    flag = true;
-    while(flag) // loop until the end of global queue "comm.mpi_comm"
-    {
-      Debug("Message probing for intracomm\n");
-     
-      #pragma omp critical (_mpi_call)
-      {
-        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, to_mpi_comm(comm.mpi_comm), &flag, &status);
-        if(flag)
-        {
-          Debug("find message in mpi comm \n");
-          mpi_source = status.MPI_SOURCE;
-          int tag = status.MPI_TAG;
-          ::MPI_Mprobe(mpi_source, tag, to_mpi_comm(comm.mpi_comm), &message, &status);
-
-        }
-      }
-      
-
-      if(flag)
-      {
-
-        MPI_Message *msg_block = new MPI_Message;
-        msg_block->mpi_message = new ::MPI_Message;
-        *(static_cast< ::MPI_Message*>(msg_block->mpi_message)) = message;
-        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong();
-        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong();
-        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();
-        int src_mpi       = status.MPI_SOURCE;
-        
-        msg_block->ep_src  = get_ep_rank_intercomm(comm, src_loc, src_mpi);
-        msg_block->mpi_status = new ::MPI_Status(status);
-        
-
-        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
-        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
-
-
-        #pragma omp critical (_query)
-        {
-          #pragma omp flush
-          comm.ep_comm_ptr->comm_list[dest_loc].ep_comm_ptr->message_queue->push_back(*msg_block);
-          #pragma omp flush
-        }
-        
-        delete msg_block;
-        
-      }
-
-    }
+          comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->push_back(msg);
+          memcheck("comm->ep_comm_ptr->comm_list["<<dest_loc<<"]->ep_comm_ptr->message_queue->size = "<<comm->ep_comm_ptr->comm_list[dest_loc]->ep_comm_ptr->message_queue->size());
+          #pragma omp flush
+        }
+      }
+    }
+
+    Message_Check_intracomm(comm);
 
     return MPI_SUCCESS;
   }
 
-  int Request_Check()
-  {
-    MPI_Status status;
-    MPI_Message message;
-    int probed = false;
-    int recv_count = 0;
-    std::list<MPI_Request* >::iterator it;
-    
-    for(it = EP_PendingRequests->begin(); it!=EP_PendingRequests->end(); it++)
-    { 
-      Message_Check((*it)->comm);
-    }
-
-
-    for(it = EP_PendingRequests->begin(); it!=EP_PendingRequests->end(); )
-    {
-      MPI_Improbe((*it)->ep_src, (*it)->ep_tag, (*it)->comm, &probed, &message, &status);
-      if(probed)
-      {
-        MPI_Get_count(&status, (*it)->ep_datatype, &recv_count);
-        MPI_Imrecv((*it)->buf, recv_count, (*it)->ep_datatype, &message, *it);
-        (*it)->type = 3;
-        EP_PendingRequests->erase(it);
-        it = EP_PendingRequests->begin();
-        continue;
-      }
-      it++;
-    }
-  }
+  
 
 }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_mpi.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_mpi.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_mpi.hpp	(revision 1520)
@@ -7,6 +7,12 @@
 MPI_Op       to_mpi_op(ep_lib::MPI_Op op);
 MPI_Comm     to_mpi_comm(void* comm);
+MPI_Comm*    to_mpi_comm_ptr(void* comm);
 MPI_Message  to_mpi_message(void* message);
-MPI_Info     to_mpi_info(void* info);
+MPI_Info     to_mpi_info(ep_lib::MPI_Info info);
+MPI_Win      to_mpi_win(void* win);
+MPI_Aint     to_mpi_aint(ep_lib::MPI_Aint aint);
+MPI_Status*  to_mpi_status_ptr (ep_lib::MPI_Status status);
+MPI_Request* to_mpi_request_ptr(ep_lib::MPI_Request request);
+MPI_Message* to_mpi_message_ptr(ep_lib::MPI_Message message);
 
 #endif // EP_MPI_HPP_INCLUDED
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_probe.cpp	(revision 1520)
@@ -6,52 +6,49 @@
 namespace ep_lib
 {
+  int MPI_Iprobe_mpi(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
+  {
+    status->ep_src = src;
+    status->ep_tag = tag;
+    return ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, to_mpi_status_ptr(*status));
+  }
 
   int MPI_Iprobe(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
   {
-    *flag = false;
+    if(!comm->is_ep)
+    {
+      Debug("MPI_Iprobe with MPI\n");
+      return MPI_Iprobe_mpi(src, tag, comm, flag, status);
+    }
+    
+    else
+    {
+      Debug("MPI_Iprobe with EP\n");
+      
+      *flag = false;
+    
+      Message_Check(comm);
 
-    if(!comm.is_ep)
-    {
-      ::MPI_Status *mpi_status = static_cast< ::MPI_Status* >(status->mpi_status);
-      ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), flag, mpi_status);
+      #pragma omp flush
 
-      status->mpi_status = mpi_status;
-      status->ep_src = src;
-      status->ep_tag = tag;
-      return 0;
-    }
-
-    Debug("calling MPI_Iprobe EP\n");
-
-    Message_Check(comm);
-
-    #pragma omp flush
-
-    #pragma omp critical (_query)
-    if(!comm.ep_comm_ptr->message_queue->empty())
-    {
-      for(Message_list::iterator it = comm.ep_comm_ptr->message_queue->begin(); it!= comm.ep_comm_ptr->message_queue->end(); ++it)
+      #pragma omp critical (_query)
+      for(Message_list::iterator it = comm->ep_comm_ptr->message_queue->begin(); it!= comm->ep_comm_ptr->message_queue->end(); ++it)
       {
-        bool src_matched = src<0? true: it->ep_src == src;
-        bool tag_matched = tag<0? true: it->ep_tag == tag;
+        bool src_matched = src<0? true: (*it)->ep_src == src;
+        bool tag_matched = tag<0? true: (*it)->ep_tag == tag;
         
         if(src_matched && tag_matched)        
         {
           Debug("find message\n");
+          
+
+          status->mpi_status = new ::MPI_Status(*static_cast< ::MPI_Status*>((*it)->mpi_status));
+          status->ep_src = (*it)->ep_src;
+          status->ep_tag = (*it)->ep_tag;
+
           *flag = true;
-
-          ::MPI_Status mpi_status = *(static_cast< ::MPI_Status *>(it->mpi_status));
-
-          status->mpi_status = new ::MPI_Status(mpi_status);
-          status->ep_src = it->ep_src;
-          status->ep_tag = it->ep_tag;
-
           break;
         }
-
       }
     }
-
-    return 0;
   }
 
@@ -60,6 +57,8 @@
   int MPI_Improbe(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status)
   {
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank    = comm->ep_comm_ptr->size_rank_info[2].first;
     *flag = false;
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
       Debug("calling MPI_Improbe MPI\n");
@@ -71,37 +70,38 @@
       #pragma omp critical (_mpi_call)
       {
-        ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), flag, &mpi_status);
+        ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_status);
         if(*flag)
         {
-          ::MPI_Mprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), &mpi_message, &mpi_status);
+          ::MPI_Mprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), &mpi_message, &mpi_status);
         }
       }
       #elif _intelmpi
-    	::MPI_Improbe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), flag, &mpi_message, &mpi_status);
+    	::MPI_Improbe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), flag, &mpi_message, &mpi_status);
       #endif
     	
-      status->mpi_status = new ::MPI_Status(mpi_status);
+      status->mpi_status = &mpi_status;
       status->ep_src = src;
       status->ep_tag = tag;
 
-      message->mpi_message = new ::MPI_Message;
-      *(static_cast< ::MPI_Message*>(message->mpi_message)) = mpi_message;
-      message->ep_src = src;
-      message->ep_tag = tag;
+      (*message)->mpi_message = &message;
+      (*message)->ep_src = src;
+      (*message)->ep_tag = tag;
+      
+      
       return 0;
     }
 
-    
-    //Message_Check(comm);
+   
 
     #pragma omp flush
 
     #pragma omp critical (_query)
-    if(! comm.ep_comm_ptr->message_queue->empty())
+    if(! comm->ep_comm_ptr->message_queue->empty())
     {
-      for(Message_list::iterator it = comm.ep_comm_ptr->message_queue->begin(); it!= comm.ep_comm_ptr->message_queue->end(); ++it)
+      for(Message_list::iterator it = comm->ep_comm_ptr->message_queue->begin(); it!= comm->ep_comm_ptr->message_queue->end(); ++it)
       {
-        bool src_matched = src<0? true: it->ep_src == src;
-        bool tag_matched = tag<0? true: it->ep_tag == tag;
+                                          
+        bool src_matched = src<0? true: (*it)->ep_src == src;
+        bool tag_matched = tag<0? true: (*it)->ep_tag == tag;
         
         if(src_matched && tag_matched)
@@ -109,22 +109,32 @@
           *flag = true;
 
-          ::MPI_Status mpi_status;
-          mpi_status = *(static_cast< ::MPI_Status *>(it->mpi_status));
+          status->mpi_status = new ::MPI_Status(*static_cast< ::MPI_Status*>((*it)->mpi_status));
+          memcheck("new "<< status->mpi_status << " : in ep_lib::MPI_Improbe, status->mpi_status = new ::MPI_Status");
+          status->ep_src = (*it)->ep_src;
+          status->ep_tag = (*it)->ep_tag;
 
-          status->mpi_status = new ::MPI_Status(mpi_status);
-          status->ep_src = it->ep_src;
-          status->ep_tag = it->ep_tag;
-
-          message->mpi_message = it->mpi_message;
-          message->ep_tag = it->ep_tag;
-          message->ep_src = it->ep_src;
+          (*message)->mpi_message = new ::MPI_Message(*static_cast< ::MPI_Message*>((*it)->mpi_message));
+          memcheck("new "<< (*message)->mpi_message <<" : in ep_lib::MPI_Improbe, (*message)->mpi_message = new ::MPI_Message");
+          (*message)->ep_src = (*it)->ep_src;
+          (*message)->ep_tag = (*it)->ep_tag;
+                                      
 
           #pragma omp critical (_query2)
           {              
-            delete it->mpi_status;
-            comm.ep_comm_ptr->message_queue->erase(it);
+            memcheck("delete "<< (*it)->mpi_message <<" : in ep_lib::Message_Check, delete (*it)->mpi_message");
+            memcheck("delete "<< (*it)->mpi_status <<" : in ep_lib::Message_Check, delete (*it)->mpi_status");
+            memcheck("delete "<< (*it) <<" : in ep_lib::Message_Check, delete (*it)");
+            
+            
+            delete (*it)->mpi_message;     
+            delete (*it)->mpi_status; 
+            delete *it;
+            
+                       
+            comm->ep_comm_ptr->message_queue->erase(it);
+            memcheck("message_queue["<<mpi_rank<<","<<ep_rank_loc<<"]->size = "<<comm->ep_comm_ptr->message_queue->size());
             #pragma omp flush
           }
-
+          
           break;
         }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_rank.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_rank.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_rank.cpp	(revision 1520)
@@ -7,42 +7,21 @@
 {
 
+  int MPI_Comm_rank(MPI_Comm comm, int* rank)
+  {
+    if(comm->is_ep)
+    {
+      Debug("MPI_Comm_rank with EP");
+      return *rank = comm->ep_comm_ptr->size_rank_info[0].first;      
+    }
+
+    return MPI_Comm_rank_mpi(comm, rank);
+  }
 
 
-  int MPI_Comm_rank(MPI_Comm comm, int* rank)
+  int MPI_Comm_rank_mpi(MPI_Comm comm, int* rank)
   {
-
-    if(comm.is_ep)
-    {
-      Debug("Calling EP_Comm_rank\n");
-
-      if(comm.is_intercomm)
-      {
-        *rank = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
-        return 0;
-      }
-      else
-      {
-        *rank = comm.ep_comm_ptr->size_rank_info[0].first;
-        return 0;
-      }
-    }
-
-
-    if(comm != MPI_COMM_NULL)
-    {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
-      ::MPI_Comm_rank(mpi_comm, rank);
-      return 0;
-    }
-    else
-    {
-      printf("rank is undefined\n");
-
-      *rank = MPI_UNDEFINED;
-      return 0;
-    }
-
+    Debug("MPI_Comm_rank with MPI");
+    return ::MPI_Comm_rank(to_mpi_comm(comm->mpi_comm), rank);
   }
-
 
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_recv.cpp	(revision 1520)
@@ -19,22 +19,11 @@
 namespace ep_lib 
 {
-  
 
   int MPI_Recv(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *status)
   {
 
-    if(!comm.is_ep)
-    {
-      ::MPI_Status mpi_status;
-      ::MPI_Recv(buf, count, to_mpi_type(datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), &mpi_status);
-
-      status->ep_src = src;
-      status->ep_tag = tag;
-      status->ep_datatype = datatype;
-
-      return 0;  
-    }
-
-    Message_Check(comm);
+    if(!comm->is_ep) return MPI_Recv_mpi(buf, count, datatype, src, tag, comm, status);
+    
+    Debug("MPI_Recv with EP");
 
     MPI_Request request;
@@ -45,92 +34,138 @@
   }
 
-
+  
 
 
   int MPI_Irecv(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Request *request)
   {
-
+    if(!comm->is_ep) return MPI_Irecv_mpi(buf, count, datatype, src, tag, comm, request);
+    
     Debug("MPI_Irecv with EP");
     int dest_rank;
     MPI_Comm_rank(comm, &dest_rank);
     
+    *request = new ep_request;   
+    memcheck("new " << *request <<" : in ep_lib::MPI_Irecv, *request = new ep_request");
 
-    if(!comm.is_ep)
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new " << (*request)->mpi_request << " : in ep_lib::MPI_Irecv, (*request)->mpi_request = new ::MPI_Request");
+    
+    (*request)->buf = buf;
+    (*request)->comm = comm;
+    (*request)->type = 2;
+    (*request)->state = 0;
+    
+
+    (*request)->ep_src = src;
+    (*request)->ep_tag = tag;
+    (*request)->ep_datatype = datatype;
+  
+    if(EP_PendingRequests == 0 ) EP_PendingRequests = new std::list< MPI_Request* >;
+
+    EP_PendingRequests->push_back(request);  
+    
+    int world_rank;
+    MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
+    if(world_rank==2) 
     {
-      ::MPI_Request mpi_request;
-      ::MPI_Irecv(buf, count, to_mpi_type(datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
+      printf("ep %d inserted one pending request %p\n", world_rank, *request);
+    }
+    
+    memcheck("EP_PendingRequests["<<ep_rank<<"]->size() = " << EP_PendingRequests->size());    
 
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->ep_src = src;
-      request->ep_datatype = datatype;
-      request->ep_tag = tag;
-    }
+#ifdef _showinfo
+    if(comm->is_intercomm)
+    {
+      int ep_dest_loc  = comm->ep_rank_map->at(dest_rank).first;
+      int ep_src_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(src).first;
+      int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+      int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(src).second.first;
 
-    request->buf = buf;
-    request->comm = comm;
-    request->type = 2;
+      printf("Irecv : ep_src_loc = %d, ep_dest_loc = %d, mpi_src = %d, mpi_dest = %d, mpi_tag = %d\n", ep_src_loc, ep_dest_loc, comm->ep_comm_ptr->size_rank_info[2].first, mpi_dest, mpi_tag);
+    }                                                          
+#endif                                      
 
-    request->ep_src = src;
-    request->ep_tag = tag;
-    request->ep_datatype = datatype;
+    return Request_Check();
+  }
+  
+  int MPI_Mrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Status *status)
+  {
+    Debug("MPI_Mrecv with MPI/EP");
 
+    status->mpi_status = new ::MPI_Status;
+    memcheck("new " << status->mpi_status << " : in ep_lib::MPI_Mrecv, status->mpi_status = new ::MPI_Status");
+    
+    ::MPI_Mrecv(buf, count, to_mpi_type(datatype), static_cast< ::MPI_Message* >((*message)->mpi_message), to_mpi_status_ptr(*status));
 
+    
+    status->ep_src = (*message)->ep_src;
+    status->ep_datatype = datatype;
+    status->ep_tag = (*message)->ep_tag;
 
-    /* With Improbe*/
-    Message_Check(comm);
+    memcheck("delete " << (*message)->mpi_message << " : in ep_lib::MPI_Mrecv, delete (*message)->mpi_message");
+    delete (*message)->mpi_message;
 
-    if(EP_PendingRequests == 0 ) 
-    {
-      EP_PendingRequests = new std::list< MPI_Request* >;
-    }
+#ifdef _check_sum
+    check_sum_recv(buf, count, datatype, message->ep_src, message->ep_tag);
+#endif
 
+    return Request_Check();
+  }
 
-    EP_PendingRequests->push_back(request);
-
-
-    Request_Check();
-
-    return 0;
-  }
 
   int MPI_Imrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Request *request)
   {
-    Debug("MPI_Imrecv");
+    Debug("MPI_Imrecv with MPI/EP");
 
-    request->type = 3;
+    (*request)->type = 3;
+    (*request)->ep_datatype = datatype;
+    (*request)->ep_tag = (*message)->ep_tag;
+    (*request)->ep_src = (*message)->ep_src;
+    
+    (*request)->state = 1;
+	
+    ::MPI_Imrecv(buf, count, to_mpi_type(datatype), to_mpi_message_ptr(*message), to_mpi_request_ptr(*request));		
+    
+    memcheck("delete " << (*message)->mpi_message << " : in ep_lib::MPI_Imrecv, delete (*message)->mpi_message");
+    delete (*message)->mpi_message;
 
-    ::MPI_Request mpi_request;
-    ::MPI_Imrecv(buf, count, to_mpi_type(datatype), static_cast< ::MPI_Message* >(message->mpi_message), &mpi_request);		
+#ifdef _check_sum
+    check_sum_recv(buf, count, datatype, message->ep_src, message->ep_tag);
+#endif
 
-    request->mpi_request = new ::MPI_Request(mpi_request);
-    request->ep_datatype = datatype;
-    request->ep_tag = message->ep_tag;
-    request->ep_src = message->ep_src;
     
-    delete message->mpi_message;
-
-    return 0;
+    return Request_Check();
   }
 
 
-  int MPI_Mrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Status *status)
+   int MPI_Recv_mpi(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *status)
   {
-    Debug("EP Mrecv called\n");
+    Debug("MPI_Recv with MPI");
+    status->ep_src = src;
+    status->ep_tag = tag;
+    status->ep_datatype = datatype;
+    
+    return ::MPI_Recv(buf, count, to_mpi_type(datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), to_mpi_status_ptr(*status)); 
+  }
+  
+  int MPI_Irecv_mpi(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("MPI_Irecv with MPI");
+    int dest_rank;
+    MPI_Comm_rank(comm, &dest_rank);
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Irecv, *request = new ep_request");
 
-    ::MPI_Status mpi_status;
-    ::MPI_Mrecv(buf, count, to_mpi_type(datatype), static_cast< ::MPI_Message* >(message->mpi_message), &mpi_status);
-
-    status->mpi_status = new ::MPI_Status(mpi_status);
-    status->ep_src = message->ep_src;
-    status->ep_datatype = datatype;
-    status->ep_tag = message->ep_tag;
-
-    delete message->mpi_message;
-
-    //check_sum_recv(buf, count, datatype, message->ep_src, message->ep_tag);
-
-    return 0;
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Irecv, (*request)->mpi_request = new ::MPI_Request");
+      
+    (*request)->ep_src = src;
+    (*request)->ep_datatype = datatype;
+    (*request)->type = 2;
+    (*request)->ep_tag = tag;
+    
+    return ::MPI_Irecv(buf, count, to_mpi_type(datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
   }
-
 }
 
